
Cls
Mode 3

'load support files
Sprite Load "ball.spr"
Font Load "brick32.fnt" As #6
Font Load "bat48.fnt" As #8

'set up hardware
pinpot = 1
SetPin pinpot,1 'pin 1 is analog paddle input
pinbut = 20
SetPin pinbut,2 'pin 20 is digital input

'initialize variables
level = 1
score = 0
brickcount = 0
balleft = 3
Dim bricks(14,7)
delta = 0
kboard = 0

'draw screen
colour = Purple
Line (4,MM.VRes - 13) - (0,20) , Purple, BF
Line (MM.HRes - 4,MM.VRes - 13) - (MM.HRes,20), Purple, BF
Line (0,20) - (MM.HRes,39), Purple, BF
Font #2
Print @(15,0) CLR$(Red) "MaxiBrick";
StartDemo
'font #1
Print @(145,6) CLR$(Green) "v0.71"
Print @(10,25) CLR$(Black, Purple) "Bricks Left:"
Print @(145,25) CLR$(Black, Purple) "Balls:"
Print @(275,25) CLR$(Black, Purple) "Level:"
Print @(380,25) CLR$(Black, Purple) "Score:"
Print @(195,6) CLR$(Yellow) "by Vegipete"
Print @(300,6) CLR$(Cyan) "picprog.strongedge.net"
UpdateScrn

xposn = Int(Pin(1) * 470 / 3.3) - 20
yposn = MM.VRes - 12
Font #8
Print @(xposn,yposn) "0" 'draw the bat at the bottom
xball = xposn + 16
xinc = .3
yball = MM.VRes -27
yinc = -1
Sprite on 1,xball,yball
DrawBricks
Do
  Timer = 0

  'Update ball position
  If pausmode = 0 Then
    xball = xball + xinc
    yball = yball + yinc
    Sprite move 1,xball,yball
  EndIf

  'Update bat position
  If demomode Then
    xposnew = xball - 24 + delta
  Else
    If kboard Then
      ky = KeyDown
      If ky = 104 Then xposnew = xposnew - 4
      If ky = 106 Then xposnew = xposnew - 2
      If ky = 107 Then xposnew = xposnew - 0
      If ky = 108 Then xposnew = xposnew + 2
      If ky =  59 Then xposnew = xposnew + 4
      If xposnew < -20 Then xposnew = -20
      If xposnew > 450 Then xposnew = 450
    Else
      xposnew = Int(Pin(pinpot) * 470 / 3.3) - 20
    EndIf
  EndIf

  If Abs(xposnew - xposn) > 2 Then
    Font #8
    Print @(xposn,yposn) "1"        'erase the old bat
    Print @(xposnew,yposn) "0"      'draw new bat
    xposn = xposnew
  EndIf

  'Test ball at edges of playing area
  If (xball < 5) Then xinc = Abs(xinc) : Tone 800,1,40 : 'Left?
  If (xball > MM.HRes - 20) Then xinc = - Abs(xinc) : Tone 1,800,40
  If (yball < 40) Then yinc = Abs(yinc) : Tone 900,900,40 : 'Top?

  'Test ball hitting (or missing) bat
  If (yball > MM.VRes - 27) Then        'Ball at bottom of screen?
    If (xball > xposn - 16) And (xball < xposn + 48) Then  'Ball hitting bat?
      Tone 700,700,40
      yinc = -Abs(yinc)
      spin = xball - xposn - 15
      xinc = xinc + spin / 20
      If xinc > 1.6 Then xinc = 1.6
      If xinc < -1.6 Then xinc = -1.6
      delta = Rnd(1) * 16
    Else    'missed the ball
      balleft = balleft - 1
      If balleft = 0 Then
        Sprite off balleft + 2
        EndGame   'game over >:-(
        Do While Inkey$ <> ""
        Loop  'clear input buffer
      Else
        Tone 440,440,300 : Pause 350
        Tone 392,392,300 : Pause 350
        Sprite off balleft + 2
        Tone 330,330,1000 : Pause 1050
        yinc = -1
        xinc = .3
        xball = xposn + 16
      EndIf
    EndIf
  EndIf

  'Test for ball hitting bricks
  i = Int((xball - 4) / 33) + 1
  k = Int((yball - 74) / 12)
  If k < 8 And k > 0 Then
    If bricks(i, k) Then
      score = score + 1
      bn = 2000 - 100 * k : Tone bn,bn,30
      brickcount = brickcount - 1
      yinc = -yinc
      Font #2
      Print @(87,20) CLR$(Black, Purple) Format$(brickcount, "%03G")
      If demomode = 0 Then
        Print @(420,20) CLR$(Black, Purple) Format$(score, "%04G")
      EndIf
      Font #6
      Sprite off 1
      Print @(i*33 - 24, k*12 + 80) CLR$(bricks(i,k)) "1"  'Erase brick
      Sprite on 1 , xball, yball
      bricks(i,k) = 0
      If brickcount = 0 Then
        level = level + 1
        Font #2
        Print @(120,120) CLR$(Yellow) "ALL BRICKS SMASHED!"
        PlayTune(400,"F52C52F52A62G52@02F52D52F52C62B62@02",50)
        PlayTune(400,"A62G54A64B64G52B64A64F54A62",50)
        PlayTune(400,"G52C64B64C64@04G54E54C52",50)

        Print @(120,120) CLR$(Black ) "                   "
        If demomode = 0 Then
          Print @(315,20) CLR$(Black, Purple) Format$(level, "%03G")
        EndIf
        Sprite off 1
        DrawBricks
        Sprite on 1, xball, yball
      EndIf
    EndIf
  EndIf

  'Scroll title - NO WAY, FAR TOO SLOW!
  'BLIT 0,0,479,0,1,19
  'BLIT 1,0,0,0,479,19

  kp = Asc(Inkey$)
  'Test for keypress and handle it
  If kp <> 0 Then
    If kp = 252 Then   'CTRL-SHIFT-F12'
      SaveBMP "MB"+Left$(Right$(Time$,5),2)+"-"+Right$(Time$,2)
    Else
      If demomode Then
        kboard = 0
        If kp = Asc("k") Then kboard = 1
        If kp <> 27 Then StartNew
      Else
        If kp = 101 Then easymode = 1 - easymode : 'Toggle easy mode
        If kp =  32 Then pausmode = 1 - pausmode : 'Toggle pause
        If kp = Asc("q") Or kp = Asc("Q") Then
          Do While balleft > 0
            Sprite off balleft + 1
            balleft = balleft - 1
          Loop
          Sprite off 1
          StartDemo
          Sprite on 1, xball, yball
        EndIf
      EndIf
    EndIf
  EndIf

  'Wait for fixed time so animation is smooth
  Do
  Loop Until Timer > 4
  If easymode Then
    Do
    Loop Until Timer > 8
  EndIf

Loop Until kp = 27
Cls
End

'******************************
'Set everything up to start a new game
Sub StartNew
  Local i

  'read current paddle position and draw bat
  Font #8
  Print @(xposn,yposn) "1"      'erase the old bat
  xposn = Int(Pin(1) * 470 / 3.3) - 20
  Print @(xposn,yposn) "0"      'draw new bat

  'set up starting ball position and speed
  xball = xposn + 16
  If xball < 5 Then xball = 5
  If xball > MM.HRes - 20 Then xball = MM.HRes - 20
  xinc = 0    'straight up
  yball = MM.VRes -27
  yinc = -1
  Sprite move 1,xball,yball

  score = 0
  level = 1
  brickcount = 0
  balleft = 3
  demomode = 0
  UpdateScrn
  DrawBricks

  'draw the players balls
  For i = 0 To balleft-1 : Sprite on 2+i,185+18*i,22 : Next

  'erase demo mode message
  Line (140,250)-(374,380),Black,bf

End Sub

'******************************
'Game over - so sad
Sub EndGame
  Font #2
  Print @(175,200) CLR$(Red) "GAME OVER"

  'Play some Chopin
  PlayTune(700,"A51A51A54A51C51B54B51A54A51A54",50)
  Tone 440,440,1000

  'Now scroll "GAME OVER" off bottom of screen
  For i = 201 To 432
    Print @(175,i) CLR$(Red) "GAME OVER"
  Next
  Sprite off 1
  StartDemo
  Sprite on 1, xball, yball
End Sub

'******************************
'Play a tune contained in a string
'
'spd is the duration of one whole note
'tune$ is a string containing the tune
'gap is the duration between notes
'
'each note consists of 3 (or 4 for sharps) characters
'Note(@-A-G, optional # for sharp)/Octave(1-8)/Duration(1=whole,2=half,etc)
'For a rest, use @0 as the note and octave
'
'Example: 'Mary Had a Little Lamb'
'PlayTune(800,"E52D52C52D52E52E52E51@08D52D52D51@08E52G52G51@08",50)
'PlayTune(800,"E52D52C52D52E52E52E52E52D52D52E52D52C51",50)
'
Sub PlayTune(spd, tune$, gap)
  Local i,fr,oc,du
  i = 1
  tune$ = UCase$(tune$)
  Do
    'read note letter and convert to 1 to 8
    fr = Asc(Mid$(tune$,i,1)) - 63 : i = i + 1
    If fr < 1 Or fr > 8 Then fr = 1
    'if sharp then shift up 7
    If Mid$(tune$,i,1) = "#" Then
      fr = fr + 8
      i = i + 1
    EndIf
    ' 2-8 are base notes, 10-16 are sharps (B# and E# don't actually exist)
    ' 1 & 9 are rests
    On fr GoTo nR,nA,nB,nC,nD,nE,nF,nG,nR,nAs,nB,nCs,nDs,nE,nFs,nGs
nR:    fr =    0 : GoTo GotNote 'rest
nA:    fr = 3520 : GoTo GotNote
nB:    fr = 3951 : GoTo GotNote
nC:    fr = 4186 : GoTo GotNote
nD:    fr = 4698 : GoTo GotNote
nE:    fr = 5274 : GoTo GotNote
nF:    fr = 5588 : GoTo GotNote
nG:    fr = 6272 : GoTo GotNote
nAs:   fr = 3729 : GoTo GotNote
nCs:   fr = 4434 : GoTo GotNote
nDs:   fr = 4978 : GoTo GotNote
nFs:   fr = 5920 : GoTo GotNote
nGs:   fr = 6644 : GoTo GotNote
GotNote:
    'read requested octave
    oc = 8 - Val(Mid$(tune$,i,1)) : i = i + 1
    Do While oc > 0
      fr = fr / 2
      oc = oc - 1
    Loop
    'read note fraction, eg: 1 = full, 4 = quarter
    du = Val(Mid$(tune$,i,1)) : i = i + 1
    If fr < 1 Then fr = 1
    Tone fr,fr,spd/du
    Pause gap + spd/du
  Loop Until i > Len(tune$)
End Sub

'******************************
'Start demo mode
Sub StartDemo
  demomode = 1    'demo mode will continue from where the game ended
  easymode = 0
  Font #2
  Print @(180,250) CLR$(Green) "Demo Mode"
  Font #1
  Print @(140,270) CLR$(Green) "press 'k' to play using keyboard,"
  Print @(148,282) CLR$(Green) "(h-j-k-l-; are movement keys)"
  Print @(145,294) CLR$(Green) "anything else to use paddle..."
  Print @(145,320) CLR$(Green) "Other keys:"
  Print @(155,332) CLR$(Green) "ESC to exit"
  Print @(155,344) CLR$(Green) "'e' to toggle Easy mode during play"
  Print @(155,356) CLR$(Green) "SPACE BAR to toggle pause"
  Print @(155,368) CLR$(Green) "'q' to quit and return to Demo mode"
End Sub

'******************************
'Update all onscreen values
Sub UpdateScrn
  Local i

  Font #2
  Print @(315,20) CLR$(Black, Purple) Format$(level, "%03G")
  Print @(420,20) CLR$(Black, Purple) Format$(score, "%04G")
  Print @(87,20) CLR$(Black, Purple) Format$(brickcount, "%03G")
End Sub

'******************************
'Fill the array with bricks and draw them on the screen
Sub DrawBricks
  brickcount = 0
  For i = 1 To 14
    Font #6
    For k = 1 To 7
      bricks(i,k) = k
      Print @(i*33 - 24, k*12 + 80) CLR$(bricks(i,k)) "0"
      brickcount = brickcount + 1
    Next k
    Font #2
    Print @(87,20) CLR$(Black, Purple) Format$(brickcount, "%03G")
  Next i
End Sub

